<template>
  <div>
    <div class="card" style="margin-bottom: 5px">
      <el-input style="width: 240px; margin-right: 10px" v-model="data.name" placeholder="请输入名称查询" prefix-icon="Search"></el-input>
      <el-button type="primary"  @click="load"> 查询</el-button>
      <el-button type="warning"  @click="reset"> 重置</el-button>
    </div>
    <div class="card" style="margin-bottom: 5px">
      <el-button type="primary"  @click = handleAdd> 新增</el-button>
      <el-button type="danger"  @click = delBatch> 批量删除</el-button>
    </div>
    <div class="card" style="margin-bottom: 5px">
      <el-table :data="data.tableData" stripe @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" />
        <el-table-column label="账号" prop="username" />
        <el-table-column label="头像">
          <template #default="scope">
            <img v-if="scope.row.avatar" :src="scope.row.avatar" alt="" style="display: block; width: 40px; height: 40px; border-radius: 50%" />
          </template>
        </el-table-column>
        <el-table-column label="名称" prop="name" />
        <el-table-column label="性别" prop="sex" />
        <el-table-column label="班级" prop="cls" />
        <el-table-column label="年龄" prop="age" />
        <el-table-column label="操作" width="120">
          <template #default="scope">
            <el-button @click="handleUpdate(scope.row)" type="primary" :icon="Edit" circle></el-button>
            <el-button @click="del(scope.row.id)" type="danger" :icon="Delete" circle></el-button>
          </template>
        </el-table-column>
      </el-table>
      <div style="margin-top: 18px">
        <el-pagination
          @size-change="load"
          @current-change="load"
          v-model:current-page="data.pageNum"
          v-model:page-size="data.pageSize"
          :page-sizes="[5, 10, 15, 20]"
          background
          layout="total, sizes, prev, pager, next, jumper"
          :total="data.total"
        />

      </div>
    </div>
    <el-dialog title="学生信息 " v-model="data.formVisible"  width="500"  destory-on-close>
      <el-form  ref="formRef" :rules="data.rules"    :model="data.form"  label-width="80px"  style="padding-right: 40px ;padding-top: 20px">
        <el-form-item label="账号"   prop="username">
          <el-input :disabled="data.form.id" v-model="data.form.username" autocomplete="off" placeholder="请输入账号" />
        </el-form-item>

        <el-form-item label="班级">
          <el-select style="width: 100%" v-model="data.form.clsId">
            <el-option v-for="item in data.clsList" :key="item.id" :label="item.name" :value="item.id"></el-option>
          </el-select>
        </el-form-item>

        <el-form-item label="名称" prop="name">
          <el-input v-model="data.form.name" autocomplete="off" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="性别">
          <el-radio-group v-model="data.form.sex">
            <el-radio  value="男"  label="男"></el-radio>
            <el-radio  value="女"   label="女"></el-radio>
          </el-radio-group>
        </el-form-item>


        <el-upload
          class="avatar-uploader"
          action="https://run.mocky.io/v3/9d059bf9-4660-45f2-925d-ce80ad6c4d15"
          :show-file-list="false"
          :on-success="handleAvatarSuccess"
          :before-upload="beforeAvatarUpload"
        >
          <img v-if="imageUrl" :src="imageUrl" class="avatar" />
          <el-icon v-else class="avatar-uploader-icon"><Plus /></el-icon>
        </el-upload>

        <el-form-item label="头像">
          <el-upload
            action="http://localhost:8080/vue/public/upload"
            list-type="picture"
            :on-success="handleAvatarSuccess"
          >
            <el-button type="primary">上传头像</el-button>
          </el-upload>
        </el-form-item>


        <el-form-item label="年龄">
          <el-input-number  style="width: 200px" :min="18" v-model="data.form.age" autocomplete="off" placeholder="请选择年龄" />
        </el-form-item>


      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button @click="data.formVisible = false">取  消</el-button>
          <el-button type="primary" @click="save">保   存</el-button>
        </div>
      </template>
    </el-dialog>

  </div>
</template>
<script setup>
import {reactive,ref} from "vue";
import {Edit, Delete, Search} from "@element-plus/icons-vue";
import request from "@/utils/utils/request.js";
import {ElMessage, ElMessageBox} from "element-plus";

request.get('/student/selectAll').then(res =>{
  data.clsList = res.data
})

const data =reactive({
  name: null,
  tableData: [],
  pageNum: 1,
  pageSize: 10,
  total: 0,
  formVisible:false,
  form:{},
  clsList:[],
  rules:{
    username:[
      {required:true,message:'请输入账号',trigger:'blur'}
    ],
    name:[
      {required:true,message:'请输入名称',trigger:'blur'}
    ],
  }
})
const handleAvatarSuccess = (res) => {
  data.form.avatar = res.data
}

const formRef =ref()
const load = () =>{
  request.get('/student/selectAll',{
    params:{
      pageNum: data.pageNum,
      pageSize: data.pageSize,
      name:data.name,
    }
  }).then(res =>{
    data.tableData = res.data;

  })
}
load();
const reset =()=>{
  data.name = null;
  load();
}
const handleAdd = ()=> {
  data.formVisible = true
  data.form = {}
}
const save = () => {
  formRef.value.validate((valid) => {
    if (valid) {
      data.form.id ? update() : add()
    }
  })
}

const add = () => {
  request.post('/student/add', data.form).then(res => {
    if (res.code === '200') {
      data.formVisible = false
      ElMessage.success('操作成功')
      load()  //新增后要重新加载新增的数据
    } else {
      ElMessage.error(res.msg)
    }
  })
}

const update = () => {
  request.put('/student/update', data.form).then(res => {
    if (res.code === '200') {
      data.formVisible = false
      ElMessage.success('操作成功')
      load()  //更新后要重新加载新增的数据
    } else {
      ElMessage.error(res.msg)
    }
  })
}
const handleUpdate = (row) => {
  data.form = JSON.parse(JSON.stringify(row))  //深拷贝一个新对象  用于编辑
  data.formVisible = true
}

const del = (id) => {
  ElMessageBox.confirm("删除数据之后无法恢复，您确定要删除这个数据吗？", '删除确认', { type: 'warning' }).then(() => {
    request.delete('/student/deleteById/' + id).then(res => {
      if (res.code === '200') {
        ElMessage.success('操作成功')
        load()  //删除 后要重新加载新增的数据
      } else {
        ElMessage.error(res.msg)
      }
    })
  }).catch(() => {
    // 用户点击取消时可以添加提示（可选）
    ElMessage.info('已取消删除');
  })
}

const handleSelectionChange = (rows) => {  // 返回所有选中的行对象数组
  // 从选中的行数组里面取出所有行的id组成一个新的数组
  data.ids = rows.map(row => row.id)
  console.log(data.ids)
}

const delBatch = () => {
  if (data.ids.length === 0) {
    ElMessage.warning("请选择数据")
    return
  }
  ElMessageBox.confirm("删除数据之后无法恢复，您确定要删除这个数据吗？", '删除确认', { type: 'warning' }).then(() => {
    request.delete('/student/deleteBatch', { data: data.ids }).then(res => {
      if (res.code === '200') {
        ElMessage.success('操作成功')
        load()  //删除 后要重新加载新增的数据
      } else {
        ElMessage.error(res.msg)
      }
    })
  }).catch(() => {
    // 用户点击取消时可以添加提示（可选）
    ElMessage.info('已取消删除');
  })
}
</script>
